<?php
/**
 * Enter description here ...
 *
 * @package Logic
 *
 * @author  alessandrobartels
 *
 */
class FGTS {


    /**
     * Enter description here ...
     *
     * @param integer               $incidencia       Incidencia.
     * @param integer               $evento           Evento.
     * @param integer               $evento_base      Evento Base.
     * @param TkDateTime            $mes_competencia  Mes Competencia.
     * @param FpaitecalcfolhaEntity $item_de_calculo  Itens de Calculo.
     * @param FpaassoceventoEntity  $assoc_eventos    Assoc_eventos.
     * @param FpaeventomEntity      $eventom          Evento.
     * @param FpavalorrefeEntity    $valor_referencia Valor Referencia.
     * @param integer               $nrOrg            Numero da Organizacao.
     *
     * @return void
     */
    public static function calcula(
         $incidencia, $evento, $evento_base, TkDateTime $mes_competencia, FpaitecalcfolhaEntity $item_de_calculo,
         FpaassoceventoEntity $assoc_eventos, FpaeventomEntity $eventom, $percentual,  $nrOrg
    ){

        $base = $item_de_calculo->calculaIncidencias($incidencia, $mes_competencia, $eventom);

        $nrevento = $assoc_eventos->retornaEvento($evento_base, $nrOrg);
        $evento_base_fgts = $eventom->retornaEvento($nrevento);

        /* Primeiro vinculo a passar aqui perde alguns itens calculos */

        // $itens  = $item_de_calculo->getItems();
        // tk_warning(' Antes - '.count($itens));
        /* foreach ($itens as $key=> $item) {
            tk_warning($item_de_calculo->getNrvinculom().' Pos: '.$key .' Evento -  '.$item->getNreventom());
        }
        */
        // tk_warning('Evento Base FGTS');
        // $item_de_calculo->geraEvento($evento_base_fgts, $mes_competencia, $base, 0, 1);.
        $item_de_calculo->geraEvento($evento_base_fgts, null, $base, 0, 1);

        /*$itens  = $item_de_calculo->getItems();
        tk_warning(' Depois - '.count($itens));
        foreach ($itens as $item) {
            tk_warning(' Evento -  '.$item->getNreventom());
        }*/

        /* Fim */

        // $indice = $item_de_calculo->procuraEvento($evento_base_fgts, $mes_competencia);.
        $indice = $item_de_calculo->procuraEvento($evento_base_fgts, null);
        /* Busca base novamente para aproveitar todo o tratamento generico do evento (centavos, valor negativo, etc.) */
        if ($indice !== -1) {
            $base = $item_de_calculo->retornaValor($indice);
        } else {
            $base = 0;
        }

//        $vr_referencia = $valor_referencia->retornaValorReferencia(1);
//        $percentual = $vr_referencia->getVrpefgts();/* retornaVrpefgts(); */

        // Para calculo de Indenizacao e Contribuicao Social na Rescisao eh usado um percentual diferente de FpaValorreferenciamEntity::FGTS
     /*   if ($valorRef === null){
            $percentual = $valor_referencia->getValorReferencia(FpaValorreferenciamEntity::FGTS);
        } else {
            $percentual = $valorRef;
        }*/

        $fgts = ($base * $percentual) / 100;

        $nrevento =  $assoc_eventos->retornaEvento($evento, $nrOrg);
        $evento_fgts = $eventom->retornaEvento($nrevento);

        // tk_warning('Evento FGTS');
        // $item_de_calculo->geraEvento($evento_fgts, $mes_competencia, $fgts, $percentual, 1);.
        $item_de_calculo->geraEvento($evento_fgts, null, (float)$fgts, $percentual, 1);
    }


    /**
     * Calcula indenizacao FGTS.
     *
     * @param FpaitecalcfolhaEntity $itemCalculo      Instancia de FpaitecalcfolhaEntity.
     * @param FpavalorrefeEntity    $valorReferencia  Instancia de FpavalorrefeEntity.
     * @param FpaassoceventoEntity  $assocEvento      Instancia de FpaassoceventoEntity.
     * @param FpaeventomEntity      $eventom          Instancia de FpaeventomEntity.
     * @param string                $tpAssocFGTSBanco Tipo de Associacao FGTS Banco.
     * @param string                $tpAssocIndBanco  Tipo de Associacao Indenizacao Banco.
     * @param integer               $nrOrg            Numero da Organizacao.
     *
     * @return void
     */
    public static function calculoIndenizacao(
        FpaitecalcfolhaEntity $itemCalculo, $percentual, FpaassoceventoEntity $assocEvento,
        FpaeventomEntity $eventom, $tpAssocFGTSBanco, $tpAssocIndBanco, $nrOrg
    ){
        $nrEventoBanco = $assocEvento->retornaEvento($tpAssocFGTSBanco, $nrOrg);
        $evento = $eventom->retornaEvento($nrEventoBanco);

        $indice = $itemCalculo->procuraEvento($evento);

        if ($indice > -1) {
            $base = $itemCalculo->retornaValor($indice);

//            $vr_referencia = $valorReferencia->retornaValorReferencia(1);
//            $percentual = $vr_referencia->getVrpefgtsrescis();
           // $percentual = $valorReferencia->getValorReferencia(FpaValorreferenciamEntity::FGTS_RESCISAO);

            $fgtsIndenizacao = ($base*$percentual)/100;

            $nrEventoInd = $assocEvento->retornaEvento($tpAssocIndBanco, $nrOrg);
            $eventoInd = $eventom->retornaEvento($nrEventoInd);

            $itemCalculo->geraEvento($eventoInd, null, $fgtsIndenizacao, $percentual, 1);
        }

    }


}